.text 
_start:
	lis r0,0xCC00 	#;-13312=0xCC00 = Hardware regs
	ori r9,r0,0x201C #;0xCC00201c 4 R/W TFBL 
					#;  Top Field Base Register (L)
					#;  (External Framebuffer Half 1)
					
	lis r4,0xC050 	#;0xC0500000 - XFB address 0x500000
	stw r4,0(r9)	#;Address of screen ram (Cache through)
	
#;Blue
	lis r3,0x00CF		#; YYBB - Blue
	ori r3,r3,0x007b 	#; YYRR
	bl CLS
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	lis r4,Hello@ha
	addi r4,r4,Hello@l	#;Load address of PrintString
	bl PrintString		
	
	bl NewLine			#;Branch and link to NewLine
	
	lis r3,0x12FE		#;Load 0x12FE into the top of R3
	ori r3,r3,0x56AB	#;Or in 0x56AB into R3
	
	bl ShowHex32		#;Branch and Link to ShowHex32
			
	bl NewLine			#;Branch and link to NewLine
		
	bl Monitor			#;Branch and link to Monitor

	lis r3,Hello@ha
	ori r3,r3,Hello@l	#;Load address of SampleData
	li r4,4
	bl MemDump
	
InfLoop:				#;This is a label
	b InfLoop			#;Branch to InfLoop
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
PrintChar:		#;Print R3
	mflr r0 			#;R0=LR
	stwu r0,-16(SP)		#;Push onto SP/R1
		
		addi sp,sp,-128
		stmw r2,0(sp)

			subi r3,r3,32 	#;No Char<Space
			slwi r3,r3,3	#;Char*8

			lis r11,MyFont@ha
			ori r11,r11,MyFont@l
			add r11,r11,r3

			lis r8,0xC050	#;0xC0500000 - XFB address (VRAM)
			
			lis r7,CharX@ha
			ori r7,r7,CharX@l
			
			lbz r4,0(r7)
			mulli r4,r4,4*8	#;Xpos *8 blocks
			add r8,r8,r4
			
			lbz r4,0(r7)
			addi r4,r4,1	#;Cursor Xpos Across 1 char
			stb r4,0(r7)
			
			lbz r4,1(r7)
			mulli r4,r4,0x5000	#;Ypos 640*2*8 blocks
			add r8,r8,r4
						
			li r7,8	#;Y-Height
			li r6,8	#;X-Width
PrintCharY:
			mtspr ctr,r6		#;X counter
			mr r10,r8			#;Backup vram
			
			lbz r4,0(r11)		#;Get a font byte
			addi r11,r11,1		#;Move to next font byte
			
PrintCharX:	
			lis r0,0xE200		#; YYBB - Yellow
			ori r0,r0,0xE294 	#; YYRR

			andi. r3,r4,0b10000000	#;Test bit
			bne PrintCharDraw
			
			lis r0,0x00CF		#; YYBB - Blue
			ori r0,r0,0x007b 	#; YYRR
			
PrintCharDraw:	
			stw r0,0(r8)		#;Line 1
			stw r0,1280(r8)		#;Line 2 (Double height)
			addi r8,r8,4
			
			slwi r4,r4,1		#;Shift font source 1 bit left
			bdnz  PrintCharX	#;X Loop
						
			mr r8,r10
			addi r8,r8,1280*2	#;Down two lines
			
			addi r7,r7,-1
			cmpwi r7,0
			bne PrintCharY     #;X Loop
			
		lmw r2,0(sp)
		addi sp,sp,128
	
	lwzu r0,0(sp)		#;POP
	addi sp,sp,16		#;POP
	mtlr r0				#;LR=R0
	blr

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PrintString:	#; Show R4 string to screen
	mflr r0 			#;R0=LR
	stwu r0,-16(SP)		#;Push onto SP/R1
PrintStringAgain:
		lbz r3,0(r4)		#;Get zero extended byte
		cmplwi r3,255		#;=255?
		beq PrintStringDone	#;Yes? then done
		bl PrintChar		#;No? then show to screen
		addi r4,r4,1		#;Inc Pointer
		b PrintStringAgain
PrintStringDone:
	lwzu r0,0(sp)		#;POP
	addi sp,sp,16		#;POP
	mtlr r0				#;LR=R0
	blr	
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
NewLine:
	addi sp,sp,-30*4
	stmw r2,0(sp)		#;Store Multiple $2+
				
		lis r3,CharX@ha
		ori r3,r3,CharX@l
		li r4,0			#;X=0
		stb r4,0(r3)
		
		lis r3,CharY@ha
		ori r3,r3,CharY@l
		lbz r4,0(r3)
		addi r4,r4,1	#;Y=Y+1
		stb r4,0(r3)
		
	lmw r2,0(sp)
	addi sp,sp,30*4
	blr
	
	.include "/SrcAll/Monitor.asm"	#;Monitor tools code
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
CLS:		
	lis r8,0xC050	#;0xC0500000 - XFB address (VRAM)

	lis r0,0x0002
	ori r0,r0,0x5800 #;0x25800=320*480 (We write 2 pixels each time)
	mtspr ctr,r0	#;Bytecount
CLSb:
	stw r3,0(r8)	#;Fill 2 pixels
	addi r8,r8,4	#;Move Vram +4
	bdnz CLSb		#;repeat
	blr	

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
.data					#;Data section

Hello:	.byte "Hello World123!"	
		.byte 255
		
CharX: .byte 0			#;Xpos in chars
CharY: .byte 0			#;Ypos in chars

MyFont:
	.incbin "/ResAll/Font96.FNT"
.text


	