
	.include "/SrcNGC/BasicHeader.asm"
	
	#;b ImmediateLoads	
	
	#;b MoveAddSub
	
	b Branches
	
ImmediateLoads:
	
	li r0,0x1234	#;Load R0 with Immediate 1234 in hexadecimal
	li r3,0x5678	#;Load R3 with Immediate 5678 in hexadecimal
		
	bl Monitor034	#;Show R0, R3 and R4
	bl NewLine
	
#;WARNING!
	#;R1/SP is the stack pointer
	#;R2 is officially the TOC pointer (Table of contents) - a pointer to a var list for subs
	#;R3-R31 are general purpose registers on a 32 bit system
	
	li r3,1234			#;Load R3 with Decimal 1234 (0x4D2)
	
	li r4,01234			#;Load R4 with Octal 1234 (0x29C)
	
	li r5,0b00001111	#;Load R5 with Binary %00001111 (0xF)
	
	bl Monitor345		#;Show R3, R4 and R5
	
	li r3,'A'			#;Load R3 with Ascii A
	li r4,'B'			#;Load R4 with Ascii B
	li r5,'C'			#;Load R5 with Ascii C
	
	bl Monitor345		#;Show R3, R4 and R5
		
	#;li r0,0x12345	#;This won't work 0x0000FFFF is the limit!
	
	lis r3,0x1234	#;We can load the top half of a register from
					#;an imedeiate (0x12340000) (Load Immediate Shifted)
	
	#;lis r3,0x12345	#;This won't work! 0xFFFF0000 is the limit!
	
	bl Monitor345	#;Show R3, R4 and R5

#;We can't load a 32 bit number in one go, but we can add two commands together!
	
	lis r3,0x1234	#;Load the top half or R3 with 0x12340000
	
	addi r3,r3,0x5678 #;Add 0x00005678, making 0x12345678
	
	bl Monitor345	#;Show R3, R4 and R5 0x12345678

	bl NewLine
	
#;.equ TestVal,0x12345678	#;Define symbol 'TestVal' as equaling 0x12345678
	
#;We want to load the TestVal into R3, but we need to split the load commands
#;into two, the assembler can calculate the two parts with @HA and @L
#;@H would get the high part, but this wouldn't give the right value for ADDI

.equ TestVal,0xFEDCBA98	#;Define symbol 'TestVal' as equaling 0xFEDCBA98
	
	li r3,TestVal@ha  	#;HA top Half for signed Addition
	li r4,TestVal@l
	
	lis r5,TestVal@ha	 #;Get the top half (High sign Adjusted) part of TestVal
	
	addi r5,r5,TestVal@l #;Get the bottom half (Low) part of Test Val

	bl Monitor345	#;Show R3, R4 and R5 0x12345678
	
	li r3,TestVal@h		#;Use @H with OR
	li r4,TestVal@l
	
	lis r5,TestVal@h	 #;Get the top half (High) part of TestVal
	ori r5,r5,TestVal@l #;Get the bottom half (Low) part of Test Val

	bl Monitor345	#;Show R3, R4 and R5 0x12345678

	b InfLoop
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MoveAddSub:
	li r3,0x1000		#;Load 0x1000 into R3
	bl Monitor345
	
#;We can use MR to Move a value from one Register to another
	
	mr r4,r3			#;Move Register R3 into R4... R4=R3
	mr r5,r3			#;Move Register R3 into R5... R5=R3
	
	bl Monitor345
	
	li r3,0x0100		#;Load R3 with 0x100
	
	addi r4,r3,0x22		#;Add Immediate 0x00000022 to R3, store in R4
	addi r5,r3,0x22		#;Add Immediate 0x00000022 to R3, Store in R5
	
	bl Monitor345
	
	li r0,0x1000		#;Load 0x1000 into R3
	li r3,0x1000		#;Load 0x1000 into R3
	
	bl Monitor034
	
	addi r0,r0,0x22		#;Add Immediate 0x00000022 to R0 ????? Actually NO!
	
	addi r3,r3,0x22		#;Add Immediate 0x00000022 to R3
	
	bl Monitor034
	
#;But WAIT!	Why did adding 0x22 to R0 result in 0x22 not 0x1022???
#;SOME commands use 'R0' as a hardwired value '0'!!!!
#;That's why R3 is our first 'general register'
#;Check out the cheatsheet for full details of which commands do this!
	
#;Why does it do this, well ACTUALLY, commands like 'li r3,0x1000' 
#; are psuedo commands, and really assemble to 'addi r3,r0,0x1000'
	
	bl NewLine
	
	li r3,0x1000
	li r4,0x0012
	
	add r5,r3,r4			#;R5=R3+R4
	bl Monitor345
	
	addis r5,r5,0x3333		#;Add Immediate Shifted <<16
	addis r3,r4,0x3333		#;Add Immediate Shifted <<16
	bl Monitor345
	
	li r5,2
	add r3,r3,r5			#;R3=R3+R5
	add r4,r4,r5			#;R4=R4+R5
	bl Monitor345
	
	li r5,3
	sub r3,r3,r5			#;R3=R3-R5 (This is actually subf r3,r5,r3)
	sub r4,r4,r5			#;R4=R3-R5 (This is actually subf r4,r5,r3)
	bl Monitor345
	
	li r5,3
	subf r3,r5,r3			#;Subtract R5 From R3 R3=R3-R5
	subf r4,r5,r3			#;Subtract R5 From R3 R4=R3-R5
	bl Monitor345
		
	subi r5,r5,0x10			#;Actually addi r5,r5,-0x10
	addi r4,r4,-0x10		#;Add Immediate 0x00000022 to R3
	bl Monitor345
	
	b InfLoop
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	
Branches:	
	li r3,'A'
	bl PrintChar		#;Show R3
	
	li r3,'B'
	bl PrintChar		#;Show R3
	
	b SkipC				#;Branch to relative address 
							#;(26 bit offset multiple of 4)
							
	;ba 0x100000 		#;Branch to absolute address 0x100000 
	
	li r3,'C'
	bl PrintChar		#;Show R3
	
SkipC:					#;This is a label in our code

	bl PrintD			#;Branch and Link, LR=Return addr
	
	#;bla 0x100000 		#;Branch and Link to absolute address 0x100000 
	
	bl PrintD

	li r3,'E'
	bl PrintChar		#;Show R3
	
	b InfLoop

	
#;This is our test subroutine
PrintD:	
	mflr r4				#;Backup LR->R4
	
		li r3,'D'
		bl PrintChar	#;Show R3 (uses LR)
		
	mtlr r4				#;Restore R4-LR
	
	blr					#;Branch to LR
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
	
	
InfLoop:	
	b       InfLoop

Monitor6:
	PushAll
		
			lwz r3,128+8(sp)
			li r4,' '
			li r5,'R'
			li r6,'0'
			bl ShowReg
				
			mr r3,r1
			addi r3,r3,128+12
			;#li r4,' '
			li r5,'S'
			li r6,'P'
			bl ShowReg
			
			
			mr r3,r2
			li r4,'T'
			li r5,'O'
			li r6,'C'
			bl ShowReg
			
			bl NewLine

			mr r7,sp
			addi r7,r7,4
			#;lwz r3,4(sp)
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,3			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr
	

Monitor034:
	PushAll
		
			lwz r3,120+8(sp)
			li r4,' '
			li r5,'R'
			li r6,'0'
			bl ShowReg

			mr r7,sp
			addi r7,r7,4
			#;lwz r3,4(sp)
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,2			#;Count
			li r9,2			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	

Monitor345:
	PushAll
		
			mr r7,sp
			addi r7,r7,4
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,3			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	
	

Monitor345678:
	PushAll
		
			mr r7,sp
			addi r7,r7,4
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,6			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	
	.include "/SrcNGC/BasicFooter.asm"

	
	
