
	.include "/SrcNGC/BasicHeader.asm"
	
	mr r10,sp			#;for our monitorstack function
	subi r10,r10,16
	
	
	#;b AddressingModes
	#;b LoadStore
	#;b LoadStore2
	#;b Stack
	#;b StackMultiple
	b StackSubAndSpecial

AddressingModes:	
	li r3,0
	li r4,0
	li r5,0

#;Signed Immediate	SIMM	16 bit signed Immediate	
	
	addi r3,r3,-1		#;R3=R3 + Signed immediate -1

#;Unsigned Immediate	UIMM	16 bit unsigned Immediate

	ori r4,r4,0xFFFF

#;Register 	rD,Ra,RB	Leftmost param is destination (rD)
	
	add r5,r5,r4		#;R5=R5+R4
	
	bl Monitor345

	
#;Register Indirect with immediate offset	d(rA)	
#;Effective Address= value in rA + 16 bit signed immediate d

	lis r3,SampledataA@ha
	ori r3,r3,SampledataA@l
	
	lbz r4,1(r3)		#;R5=(R3+1)
	
#;Register Indirect with index	rA,Rb
#;	Effective Address = value in rA + rB
#;mnemnonic has suffix X

	li r6,2
	lbzx r5,r3,r6		#;R5=(R3+R6)

	bl Monitor345
	
	li r4,1			#;Lines
	bl MemDump		#;show R4 lines of R3
	
	bl NewLine
	bl NewLine
	
#;With Update
#;U suffix 
		
	lis r3,SampledataA@ha
	ori r3,r3,SampledataA@l
	li r6,2
		
	bl Monitor345
	
	lbzu r4,1(r3)		#; R3=R3+1, R5=(R3+1)
	
	bl Monitor345
	
	li r6,2
	lbzux r5,r3,r6		#;R3=R3+R6 R5=(R3+R6)
	
	bl Monitor345
	
	bl NewLine
	
#;With CR Update
#;. suffix 

	lis r3,0xFFFF
	ori r3,r3,0xFFFD
	li r4,1
	add. r3,r3,r4
	
	li r0,6				#; Count=4
	mtctr r0			#;Move to CounT Register 
	
AddAgain:	
	bl Monitor6
	
	add. r3,r3,r4		#;. = Update condition codes
		
	bdnz AddAgain		#;Branch after Decrementing CTR if NonZero
	
	

	b InfLoop


.data
SampledataA:
	.long 0xFEDCBA98,0x12345678		
	.long 0,0,0,0
.text
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
Stack:	
	bl MonitorStack
	
	li r3,0x1234
	stwu r3,-4(SP)		#;Push R3 onto Stack

	li r3,0x5678
	stwu r3,-4(SP)		#;Push R3 onto Stack
	
	bl MonitorStack
	
	lwzu r4,0(sp)		#;POP R4
	addi sp,sp,4		#;Add 4 to SP
	
	lwzu r5,0(sp)		#;POP R5
	addi sp,sp,4		#;Add 4 to SP
	
	bl MonitorStack
	
	b InfLoop

	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
StackMultiple:
	bl MonitorStack
	
	li r29,0x3333
	li r30,0x4444
	li r31,0x5555
	
	addi sp,sp,-4*3
	stmw r29,0(sp)		#;Store Multiple R29+
	
	bl MonitorStack
	
	lmw r29,0(sp)		#;Load Multiple R29+
	addi sp,sp,4*3
	
	bl MonitorStack
	
	b InfLoop
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
StackSubAndSpecial:		
	li r0,0x1234

	bl SubTest
	
	bl Monitor
	
	b InfLoop

#;We need to back up the LR if we're using nested subs 
#;we can't do this directly, but can transfer it to the stack via R0

SubTest:
	stwu r0,-4(SP)		#;Push R0 onto SP/R1

	mfcr r0 			#;R0=CR
	stwu r0,-4(SP)		#;Push CR onto SP/R1
	
	mflr r0 			#;R0=LR
	stwu r0,-4(SP)		#;Push LR onto SP/R1

		bl MonitorStack
	
	lwzu r0,0(sp)		#;POP LR
	addi sp,sp,4		#;POP
	mtlr r0				#;LR=R0
	
	lwzu r0,0(sp)		#;POP R0
	addi sp,sp,4		#;POP
	mtcrf 0xFF,r0		#;CR=R0
	
	lwzu r0,0(sp)		#;POP R0
	addi sp,sp,4		#;POP
	
	blr
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
LoadStore:

	lis r8,Sampledata@ha
	addi r8,r8,Sampledata@l
	
	lbz r3,0(r8)	#;Load Byte and Zero extend (8 bit)
	lhz r4,0(r8)	#;Load Half and Zero extend (16 bit)
	lwz r5,1(r8)	#;Load Word (32 bit)
	
	lha r6,0(r8)	#;Load Half Algebraic (Sign Extended)
	lha r7,4(r8)	#;Load Half Algebraic (Sign Extended)
	
	#;lba r3,0,(r8)	#;No such command as Load Byte Algebraic - use EXTSB
	#;lha r7,4(r0)	#;R0 is a hardwired zero, 
						#; so 4(r0) will load from address 0+4	
	bl Monitor345678
	
	
	lis r5,Sampledata@ha
	addi r5,r5,Sampledata@l
	
	la r3,4(r5)		#;Load Address 4(R5) into R3... 
	la r4,16(r5)		#;effectively R3=R5+4 (AddI)
	
	bl Monitor345
	
	lwz r3,0(r5)
	
	stb r3,8(r5)	#;Store byte to (R5)+8		(8 bit)
	sth r3,12(r5)	#;Store Half to (R5)+12		(16 bit)
	stw r3,17(r5)	#;Store Word to (R5)+17		(32 bit)
					#;Can load and store to odd byte boundaries!++++++++++++
	bl Monitor345
	
	lis r3,Sampledata@ha
	ori r3,r3,Sampledata@l
	li r4,3
	bl MemDump
	
	b InfLoop
	
	
.data
Sampledata:
	.long 0xFEDCBA98,0x12345678
	.long 0,0,0,0
.text

	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LoadStore2:
	lis r8,Sampledata2@ha
	addi r8,r8,Sampledata2@l
	li r0,8			#;Set to prove R0 is hardwired zero

	lwz r3,0(r8)	#;Load Word (32 bit)
	lwbrx r4,r0,r8	#;Load Word Byte Reversed indeXed (R0=Hardwired Zero)
	
	lhbrx r5,r0,r8  #;Load Half Byte Reversed indeXed

#;Also matching Store commands
#;	sthbrx rS,rA,rB	Store Half Word Byte-Reverse Indexed
#;	stwbrx rS,rA,rB	Store Word Byte-Reverse Indexed	
	
	bl Monitor345678
	
	addi r8,r8,1
	
	lswi r3,r8,6	#;Load String Word Immediate
	
	li r0,6
	mtspr xer,r0	#;Set Bytecount bits of XER
	li r5,2
					#;Load String Word Indexed
	lswx r6,r8,r5	#;Load XER bits (0-127) from (R5+R8)
	
	bl Monitor345678
	
#;Also matching Store commands
#;	stswi rS,rA,NB	Store String Word Immediate
#;	stswx rS,rA,rB	Store String Word Indexed
	
	addi r8,r8,16
	stswi r3,r8,6	#;Load String Word Immediate
		
	lis r3,Sampledata2@ha
	ori r3,r3,Sampledata2@l
	li r4,3
	
	bl MemDump	
	b InfLoop

.data
Sampledata2:
	.long 0xFEDCBA98,0x12345678
	.long 0x11223344,0x55667788,0,0
.text
	

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
	
InfLoop:	
	b       InfLoop

MonitorStack:
	pushall
		bl Monitor6
	
		mr r3,r10
		li r4,2
	
		bl MemDump
		
	popall
	blr
		
Monitor6:
	PushAll
			lwz r3,120+8(sp)
			li r4,' '
			li r5,'R'
			li r6,'0'
			bl ShowReg
				
			mr r3,r1
			addi r3,r3,120+12
			;#li r4,' '
			li r5,'S'
			li r6,'P'
			bl ShowReg
			
			lwz r3,120+4(sp)
			#;li r4,' '
			li r5,'C'
			li r6,'R'
			bl ShowReg
						
			bl NewLine

			mr r7,sp
			addi r7,r7,4
			#;lwz r3,4(sp)
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,3			#;Count
			li r9,3			#;show on line
			bl ShowRegs
	PopAll
	blr
	

Monitor345:
	PushAll
			mr r7,sp
			addi r7,r7,4
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,3			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	
	
Monitor345678:
	PushAll
		
			mr r7,sp
			addi r7,r7,4
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,6			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	
	.include "/SrcNGC/BasicFooter.asm"

	
	
