
	.include "/SrcNGC/BasicHeader.asm"
	
	
	#;b Compares
	#;b Compares2
	#;b CondReg
	b CountRegister
	
	
Compares:
	li r3,100
	li r4,110
	#;li r4,90
	#;li r4,-110
	
#;cmp crfD,L,rA,rB 
	cmp 7,0,r3,r4			#;The CR actually has 8 sets of flags
	cmp 6,1,r3,r4			#;1=64 bit mode... doesn't work on 32 bit cpu
	cmp 5,0,r3,r4
	cmp 4,0,r3,r4	
	cmp CR2,0,r3,r4			#;Can specify 2 or CR2 as parameter
	
	bl Monitor6
	
#;Simple versions defaults to CR0
	cmpw r3,r4				#;CoMPare Word signed 
	
	cmplw r3,r4				#;CoMPare Logical Word unsigned
	
	bl Monitor6
	
#;Simple branches are easiest for everyday use.
	
	bgt ShowGT			#;Is R3>R4
	blt ShowLT			#;Is R3<R4
	
#; +- are optional, they tell the assembler if we expect 
#; the branch to occur allowing the CPU to run more efficiently	
	
	beq+ ShowEQ				#;Is R3=R4
	bne- ShowNE				#;Is R3!=R4
		
#;Bcc are psuedo ops for BC BO,BI
	
	bc 0b01100,1,ShowGT	#; 0b01100=TRUE / 1=GT in CR 
	bc 0b01100,0,ShowLT	#; 0b01100=TRUE / 0=LT in CR
	
	bt gt,ShowGT		#;Branch True
	bt lt,ShowLT		#; BF also exists (Branch False)

	bl Monitor6
	
	b InfLoop
	
#;BO Bits	Meaning
#;0000y		Decrement the Count Register (CTR), then branch if CTR is not zero and the condition is FALSE.
#;0001y		Decrement the Count Register (CTR), then branch if the decremented CTR equals zero and the condition is TRUE.
#;0010y		Branch if the condition is FALSE.
#;0100y		Decrement the Count Register (CTR), then branch if CTR is not zero and the condition is TRUE.
#;0101y		Decrement the Count Register (CTR), then branch if the decremented CTR equals zero and the condition is TRUE.
#;0110y		Branch if the condition is TRUE.
#;1000y		Decrement the CTR, then branch if the CTR is not zero.
#;1001y		Decrement the CTR, then branch if the CTR equals zero.
#;10100		Branch always.
	

#;Full list of options:
	#;blt target	Branch if less than
	#;ble target	Branch if less than or equal
	#;beq target	Branch if equal 
	#;bge target	Branch if greater than or equal
	#;bgt target	Branch if greater than 
	#;bnl target	Branch if not less than  
	#;bne target	Branch if not equal
	#;bng target	Branch if not greater than
	#;bso target	Branch if summary overflow
	#;bns target	Branch if not summary overflow
	#;bun target	Branch if unordered 
	#;bnu target	Branch if not unordered
	
	
ShowGT:
		li r3,'>'
		bl PrintChar		#;Show R3
	b InfLoop
	
ShowLT:
		li r3,'<'
		bl PrintChar		#;Show R3
	b InfLoop
	
ShowEQ:
		li r3,'='
		bl PrintChar		#;Show R3
	b InfLoop


ShowNE:
		li r3,'!'
		bl PrintChar		#;Show R3
		li r3,'='
		bl PrintChar		#;Show R3
	b InfLoop
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
Compares2:
	li r3,100
	li r4,110
	#;li r4,90
	li r4,-110
	
	bl Monitor6
	
	#;Simple versions defaults to CR0
	cmpw r3,r4			#;CoMPare Word signed 
	cmplw r3,r4			#;CoMPare Logical Word unsigned
	
	bl LinkCond			#;Branch to our test sub

	li r3,'Y'
	bl PrintChar		#;Show R3
	b InfLoop

LinkCond:
		#;Simple versions defaults to CR0
		cmpw r3,r4			#;CoMPare Word signed 
		cmplw r3,r4			#;CoMPare Logical Word unsigned
		
		bltlr 				#;Return to LR if R3<R4
		
		li r3,'N'
		bl PrintChar		#;Show R3
	b InfLoop
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
CondReg:
	mfcr r3 			#;Move From CR   R3=CR
	
	bl Monitor6
		
	lis r0,0xFEDC
	ori r0,r0,0xBA87
	mtcrf 0b01111111,r0	#;Move To CR Fields 
						#;mask defines which CR fields are copied from R0
	bl Monitor6
	
	mcrf 7,6			#;Move from CR Field CR7=CR6
	mcrf CR5,CR4		#;Move from CR Field CR5=CR4
	
	bl Monitor6
	
	crand 0,28,24		#;	AND CR bit 28 with bit 24, store result in bit 0
	
	bl Monitor6
	
#;You probably won't need them, but there are a large range of such commands!

#;	crand crbD,crbA,crbB	Condition Register AND
#;	cror crbD,crbA,crbB	Condition Register OR
#;	crxor crbD,crbA,crbB	Condition Register XOR
#;	crnand crbD,crbA,crbB	Condition Register NAND
#;	crnor crbD,crbA,crbB	Condition Register NOR
#;	creqv crbD,crbA,crbB	Condition Register Equivalent
#;	crandc crbD,crbA,crbB	Condition Register AND with Complement
#;	crorc crbD,crbA,crbB	Condition Register OR with Complement
		
	
	lis r0,0x7000
	mtxer r0		#;load a test value into the top bits of XER
	
	mcrxr 7			#;Move top 4 bits of XER to CR7, XER bits cleared
	
	bl Monitor
	
	b InfLoop

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			
#;mtspr/mfspr allows us to access special purpose registers MQ,XER,RTCU,RTCL,DEC,LR,CTR
	
CountRegister:
	li r3,0
	li r4,4
	
	mtspr ctr,r4	#;Move to Special Purpose Register CTR <-R4
	
	mfspr r5,ctr	#;Move From Special Purpose Register CTR -> R5
		
	#;Can also use "mtctr r3"
	bl Monitor
	
LoopTest:
	addi r3,r3,1
	bl ShowHex32
	bl NewLine
		
	bdnz LoopTest		#;Decrement CTR and branch if CTR!=0


#;BDNZF or BDNZT allow us to loop, but have a breakout condition	
		
	li r3,0
	li r4,4
	mtspr ctr,r4		#;Can also use "mtctr r3"

	bl NewLine
	
LoopTest2:
	addi r3,r3,1
	bl ShowHex32
	bl NewLine
	
	cmpwi r3,2				#;Compare R3 to 2
	
	bdnzf eq,LoopTest2		#;Decrement CTR and branch if CTR!=0 
								#; and condition False (R3 EQual 2)

	b InfLoop


#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
	
InfLoop:	
	b       InfLoop

Monitor6:
	PushAll
			lwz r3,120+8(sp)
			li r4,' '
			li r5,'R'
			li r6,'0'
			bl ShowReg
				
			mr r3,r1
			addi r3,r3,120+12
			;#li r4,' '
			li r5,'S'
			li r6,'P'
			bl ShowReg
			
			
			lwz r3,120+4(sp)
			#;li r4,' '
			li r5,'C'
			li r6,'R'
			bl ShowReg
			
			bl NewLine

			mr r7,sp
			addi r7,r7,4
			#;lwz r3,4(sp)
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,3			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr
	

Monitor034:
	PushAll
			lwz r3,120+8(sp)
			li r4,' '
			li r5,'R'
			li r6,'0'
			bl ShowReg

			mr r7,sp
			addi r7,r7,4
			#;lwz r3,4(sp)
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,2			#;Count
			li r9,2			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	

Monitor345:
	PushAll
			mr r7,sp
			addi r7,r7,4
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,3			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	
	

Monitor345678:
	PushAll
			mr r7,sp
			addi r7,r7,4
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,6			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	
	.include "/SrcNGC/BasicFooter.asm"

	
	
