
	.include "/SrcNGC/BasicHeader.asm"
	
	#;b Carries
	#;b ZeroExtend
	#;b MultiplyDivide
	b SpecialCommands

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
Carries:
	li r3,1
	lis r4,0xFFFF
	ori r4,r4,0xFFFC
	
	li r5,0
	li r6,1
	
	li r0,8				#; Count
	bl Monitor345
	
#;We can combine AddC and AddE/AddZE for 64 bit+ maths
	
	mtctr r0			
CarryAgain:	
	#;addc r4,r4,r6		#;R4=R4+R6... Set XER[CA]
	
	addic r4,r4,1		#;R4+R4+1... Set XER[CA]
	
	#;adde r3,r3,r5		#;R3=R3+R5+XER[CA]
	
	addze r3,r3			#;R3=R3+0+XER[CA]
	
	bl Monitor345
	bdnz CarryAgain
	
	bl NewLine
	
	
	li r0,8				#; Count
	mtctr r0			
CarryAgain2:	
	subfc r4,r6,r4		#;R4=R4-R6... Set XER[CA]
	
	subfe r3,r5,r3		#;R3=(R3-(1-XER[CA])-R5
		
	#;Subfze doesn't do what we need here!
	#;subfze r3,r3		#;R3=(0-R3)-(1-XER[CA])

	bl Monitor345
	bdnz CarryAgain2
	
	b InfLoop	

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
MultiplyDivide:
	li r3,0
	li r4,0
	lis r5,0x8765
	ori r5,r5,0x4321
	
	li r6,0x1000
	
	bl Monitor6
	
	mullw r4,r5,r6	#;Get low part of 64 bit result R5*R6
	
	mulhw r3,r5,r6	#;Get high part of 64 bit result R5*R6 (signed)
	
	bl Monitor6
	bl NewLine
	
	li r3,0
	li r4,0
	lis r5,0x8765
	ori r5,r5,0x4321
	
	li r6,0x1000
	
	bl Monitor6
	
	mullw r4,r5,r6	#;Get low part of 64 bit result R5*R6
	
	mulhwu r3,r5,r6	#;Get high part of 64 bit result R5*R6 (unsigned)
	
	bl Monitor6
	bl NewLine
		
	li r5,0x1234
	mulli r4,r5,0x100 #;Low part can multiply by immediate
	
	bl Monitor6
	bl NewLine
	
	lis r5,0x8765
	ori r5,r5,0x4321
	
	li r6,0x1000
	
	divw r3,r5,r6	#;Divide Signed R5 by Signed R6, Result in R3
	
	divwu r4,r5,r6	#;Divide Unsigned R5 by Unsigned R6, Result in R3
	
	bl Monitor6

	b InfLoop	
	

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
ZeroExtend:
	li r3,5
	li r4,5
	lis r0,0x2000		#;Carry Set
	mtxer r0			#;Move To XER
	
	subfze r3,r3		#;R3=(0-R3)-(1-XER[CA])
	
	mtxer r0			#;Move To XER
	
	addze r4,r4			#;R4=0+R4+XER[CA]
	
	bl Monitor345
	bl NewLine
	
	li r3,5
	li r4,5
	lis r0,0x0000		#;Carry Clear
	mtxer r0			#;Move To XER
	
	subfze r3,r3		#;(0-R3)-(1-XER[CA])
	
	mtxer r0			#;Move To XER
	
	addze r4,r4			#;R4=0+R4+XER[CA]
	
	bl Monitor345
	bl NewLine
	bl NewLine
	
	li r3,5
	li r4,5
	lis r0,0x2000		#;Carry Set
	mtxer r0			#;Move To XER
	
	subfme r3,r3		#;R3=(-1-R3)-(1-XER[CA])
	
	mtxer r0			#;Move To XER
	
	addme r4,r4			#;R4=-1+R4+XER[CA]
	
	bl Monitor345
	bl NewLine
			
	li r3,5
	li r4,5
	lis r0,0x0000		#;Carry Clear
	mtxer r0			#;Move To XER
	
	subfme r3,r3		#;(-1-R3)-(1-XER[CA])
	
	mtxer r0			#;Move To XER
	
	addme r4,r4			#;R4=-1+R4+XER[CA]
	
	bl Monitor345

	
	
	b InfLoop
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpecialCommands:

	nop 			#;Do nothing (ori 0,0,0)

	sc				#;Performa asystem call	
	
	li r3,1
	li r4,1
	
	tw 0b00100,r3,r4 #;Trap if r3 ? r4 based on bits % LTs GTs EQ LTu GTu
	
	twi 0b00100,r3,1 #;Trap if r3 ? immediate based on bits % LTs GTs EQ LTu GTu
		
	bl Monitor345	
		
	b InfLoop
	
InfLoop:	
	b       InfLoop

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Monitor6:
	PushAll
			lwz r3,128+8(sp)
			li r4,' '
			li r5,'R'
			li r6,'0'
			bl ShowReg
				
			mr r3,r1
			addi r3,r3,128+12
			;#li r4,' '
			li r5,'S'
			li r6,'P'
			bl ShowReg
			
			
			lwz r3,128+4(sp)
			#;li r4,' '
			li r5,'C'
			li r6,'R'
			bl ShowReg
			
			bl NewLine

			mr r7,sp
			addi r7,r7,4
			#;lwz r3,4(sp)
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,3			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
	

Monitor034:
	PushAll
			lwz r3,120+8(sp)
			li r4,' '
			li r5,'R'
			li r6,'0'
			bl ShowReg

			mr r7,sp
			addi r7,r7,4
			#;lwz r3,4(sp)
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,2			#;Count
			li r9,2			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	

Monitor345:
	PushAll
			mr r7,sp
			addi r7,r7,4
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,3			#;Count
			li r9,3			#;show on line
			bl ShowRegs
	PopAll
	blr	
	

Monitor345678:
	PushAll
			mr r7,sp
			addi r7,r7,4
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,6			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	
	.include "/SrcNGC/BasicFooter.asm"

	
	
