.text 
_start:
	lis r0,0xCC00 	#;-13312=0xCC00 = Hardware regs
	ori r9,r0,0x201C #;0xCC00201C TFBL 
					#;  Top Field Base Register (L)
					#;  (External Framebuffer Half 1)
					
	lis r4,0xC050 	#;0xC0500000 - XFB address 0x500000
	stw r4,0(r9)	#;Address of screen ram (Cache through)
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
#;Color in RGB:	
#; R = (R1+R2)/2
#; G = (G1+G2)/2
#; B = (B1+B2)/2

#;Luminance:
#; Y1 = (77/256)*R1 + (150/256)*G1 + (29/256)*B1
#; Y2 = (77/256)*R2 + (150/256)*G2 + (29/256)*B2
#;Encoded Color:
#; cB = -(44/256)*R - (87/256)*G + (131/256)*B + 128
#; cR = (131/256)*R - (110/256)*G - (21/256)*B + 128

#;Result $YYBBYYRR (Y1 cB Y2 cR)


#;Black
	lis     r3,0x0080		#; YYBB
	ori     r3,r3,0x0080 	#; YYRR	
	bl CLS
	
#;Draw sample color blocks (R3=Color)
		
	li r5,0	#;Xpos for colorblocks
	li r6,0 #;Ypos for colorblocks
	
#;Black
	lis     r3,0x0080		#; YYBB
	ori     r3,r3,0x0080 	#; YYRR
	bl QuickBlock
	
#;Grey
	lis     r3,0x8080		#; YYBB
	ori     r3,r3,0x8080 	#; YYRR	
	bl QuickBlock
	
#;White
	lis     r3,0xFF80		#; YYBB
	ori     r3,r3,0xFF80 	#; YYRR
	bl QuickBlock

#;RED 
	lis     r3,0x4C54		#; YYBB
	ori     r3,r3,0x4CFF 	#; YYRR
	bl QuickBlock
	
#;Green
	lis     r3,0x9429		#; YYBB
	ori     r3,r3,0x9512 	#; YYRR
	bl QuickBlock
	
#;Blue
	lis     r3,0x1cFF		#; YYBB
	ori     r3,r3,0x1c6b 	#; YYRR
	bl QuickBlock

#;Cyan
	lis     r3,0xb2AB		#; YYBB
	ori     r3,r3,0xB200 	#; YYRR
	bl QuickBlock
	
#;Magenta
	lis     r3,0x69D6		#; YYBB
	ori     r3,r3,0x69ED 	#; YYRR
	bl QuickBlock

#;Yellow
	lis     r3,0xE200		#; YYBB
	ori     r3,r3,0xE294 	#; YYRR
	bl QuickBlock
	
#;orange
	lis r3,0x9728			#; YYBB
	ori r3,r3,0x97CB 		#; YYRR
	bl QuickBlock
		
#;Purple
	lis r3,0x1a95			#; YYBB
	ori r3,r3,0x1a9b		#; YYRR	
	bl QuickBlock
			
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

#;Draw our mascot
	
	li r5,260
	li r6,64
	bl GetScreenPos		#;Get VRRAM R4 for XY pos R5,R6
	
	lis r3,Bitmap1x@ha
	ori r3,r3,Bitmap1x@l
	li r5,48/2			#;Width in 32 bit words (pairs of pixels)
	li r6,48			#;height in lines
	bl DrawBitmap1x		#;Draw high res
	
	
	li r5,320
	li r6,64
	bl GetScreenPos		#;Get VRRAM R4 for XY pos R5,R6
	
	lis r3,Bitmap2x@ha	#;2x scale so we don't need to worry about color issues
	ori r3,r3,Bitmap2x@l
	
	li r5,48			#;width in pairs of pixels
	li r6,48			#;height in pairs of lines
	bl DrawBitmap2x		#;draw Double size
	
InfLoop:	
	b InfLoop
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
		
DrawBitmap2x:		
DrawBitmap2xY:
	mtspr ctr,r5		#;Width to -> CTR
	mr r8,r4		
DrawBitmap2xX:
	lwz r0,0(r3)		#;Get 2 pixels
	stw r0,0(r8)		#;Draw 2 pixels
	stw r0,1280(r8)		#;Duplicate one line down
	addi r8,r8,4
	addi r3,r3,4
	bdnz DrawBitmap2xX
	
	addi r4,r4,1280*2	#;Down two lines
	addi r6,r6,-1
	cmpwi r6,0
	bne DrawBitmap2xY
	blr
		
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

DrawBitmap1x:
DrawBitmap1xY:
	mtspr ctr,r5		#;Width to -> CTR
	mr r8,r4
DrawBitmap1xX:
	lwz r0,0(r3)		#;Get 2 pixels
	stw r0,0(r8)		#;Draw 2 pixels
	addi r8,r8,4
	addi r3,r3,4
	bdnz DrawBitmap1xX	
	
	addi r4,r4,1280		#;Down a line
	addi r6,r6,-1
	cmpwi r6,0
	bne DrawBitmap1xY
	blr
	
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
	
QuickBlock:
	mflr r0 				#;R0=LR
	stwu r0,-4(SP)			#;Push LR onto SP/R1
				
	addi sp,sp,-30*4
	stmw r2,0(sp)			#;Store Multiple $2+
		
		bl GetScreenPos
	
		li r5,48/2			#;width in words (pairs of pixels)
		li r6,48			#;height in pairs of lines
		bl FillArea	
	
	lmw r2,0(sp)
	addi sp,sp,30*4
	
	lwzu r0,0(sp)			#;POP LR
	addi sp,sp,4			#;POP
	mtlr r0					#;LR=R0
	
	addi r5,r5,48			#;Move across one block
	blr
	
	
FillArea:		#;R1=Fill 
FillAreaY:
	mtspr ctr,r5		#;CTR=Xpos
	mr r8,r4
FillAreaX:
	stw r3,0(r8)		#;Fill 2 bytes
	addi r8,r8,4
	bdnz FillAreaX	
	
	addi r4,r4,1280		#;Down a line
	addi r6,r6,-1
	cmpwi r6,0
	bne FillAreaY
	blr

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
GetScreenPos:		#;R5=X R6=Y... Result in R4
	lis r4,0xC050		 #;0xC0500000 - XFB address
	ori r4,r4,0x0000
	
	li r0,640*2			#;640 pixels per y-line,2 bytes per pixel
	mullw r6,r6,r0
	add r4,r4,r6
	
	li r0,2				#;2 bytes per X-Pixel
	mullw r5,r5,r0
	add r4,r4,r5
	blr 
	

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
CLS:		
	lis r8,0xC050	#;0xC0500000 - XFB address (VRAM)

	lis r0,0x0002
	ori r0,r0,0x5800 #;0x25800=320*480 (We write 2 pixels each time)
	mtspr ctr,r0	#;Bytecount
CLSb:
	stw r3,0(r8)	#;Fill 2 pixels
	addi r8,r8,4	#;Move Vram +4
	bdnz CLSb		#;repeat
	blr	

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
		
	
.data

Bitmap1x: 
	.incbin "/ResAll/RawSpriteGC_1x.RAW"
	
Bitmap2x: 
	.incbin "/ResAll/RawSpriteGC_2x.RAW"
	
	
	

	