#;.equ showtext,1

.ifdef showtext
	.include "/SrcNGC/BasicHeader.asm"	
.else

_start:
	lis     r4,-0x3FB0 #;0xC0500000 - XFB address
	
	lis     r0,-13312 #;-13312=0xCC00 = Hardware regs
	cmplwi  cr7,r3,1
	ori     r9,r0,8220 #;0xCC00201c 4 R/W TFBL - Top Field Base Register (L) (External Framebuffer Half 1)
	
	stw     r4,0(r9)	
	
.endif
	
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

	
#;Color in RGB:	
#; R = (R1+R2)/2
#; G = (G1+G2)/2
#; B = (B1+B2)/2

#;Luminance:
#; Y1 = (77/256)*R1 + (150/256)*G1 + (29/256)*B1
#; Y2 = (77/256)*R2 + (150/256)*G2 + (29/256)*B2
#;Encoded Color:
#; cB = -(44/256)*R - (87/256)*G + (131/256)*B + 128
#; cR = (131/256)*R - (110/256)*G - (21/256)*B + 128

#;Result $YYBBYYRR (Y1 cB Y2 cR)


#;Black
	lis r3,0x0080	 #; YYBB
	ori r3,r3,0x0080 #; YYRR
	bl CLS2
	
	bl DrawSprites			#;Draw the starting pos of the sprite
	
	bl JoyInit				#;Prep the joystick
	
InfLoop:	
.ifdef showtext
		lis r3,CharX@ha
		ori r3,r3,CharX@l
		li r4,0
		stb r4,0(r3)		#;Load Cursor X =0
		
		lis r3,CharY@ha
		ori r3,r3,CharY@l
		li r4,29
		stb r4,0(r3)		#;Load Cursor Y =29
.endif
		
	lis r8,0xCC00		#;0xCC006400	SI - Serial Interface
	ori r8,r8,0x6400
	
.ifdef showtext	
	lwz r3,4(r8)		#;0xCC006404  Joy-channel 1 Buttons 1 
	bl ShowHex32		#; 			  %---syxba--lrUDRLXXXXXXXXYYYYYYYY
.endif
.ifdef showtext	
	lwz r3,8(r8)		#;0xCC006408 Joy-channel 1 Buttons 2
	bl ShowHex32		#;			  %XXXXXXXXYYYYYYYYLLLLLLLLRRRRRRRR
.endif

	lwz r3,4(r8)		#; %---syxba--lrUDRLXXXXXXXXYYYYYYYY
	lwz r4,8(r8)		#; %XXXXXXXXYYYYYYYYLLLLLLLLRRRRRRRR
	
	lis r10,UserRam@ha
	ori r10,r10,UserRam@l
	
	lwz r11,U_PosX1(r10) #;XY pos for digital pad sprite
	lwz r12,U_PosY1(r10)
		
	lwz r13,U_PosX2(r10) #;XY pos for analog pad sprite
	lwz r14,U_PosY2(r10)
		
		
	li r15,0			#;Flag no update
								
	lis r6,0x0001		#;0x00010000 - For testing directions
	ori r6,r6,0x0000
	
	#;Bit order %---syxba--lrUDRLXXXXXXXXYYYYYYYY
	and. r0,r3,r6		#;Test bit
	beq Joy1NotL
	cmpwi r11,0			#;At far left?
	beq Joy1NotL
	addi r11,r11,-2		#;Move Left
	li r15,1			#;Flag redraw
Joy1NotL:

	slwi r6,r6,1
	and. r0,r3,r6		#;Test bit
	beq Joy1NotR
	cmpwi r11,640-48	#;At far right?
	beq Joy1NotR
	addi r11,r11,2		#;Move Right
	li r15,1			#;Flag redraw
Joy1NotR:

	slwi r6,r6,1
	and. r0,r3,r6		#;Test bit
	beq Joy1NotD
	cmpwi r12,480-48	#;At bottom?
	beq Joy1NotD
	addi r12,r12,2		#;Move Down
	li r15,1			#;Flag redraw
Joy1NotD:

	slwi r6,r6,1
	and. r0,r3,r6		#;Test =0xFF
	beq Joy1NotU
	cmpwi r12,0			#;At Top?
	beq Joy1NotU
	addi r12,r12,-2		#;Move Up
	li r15,1			#;Flag redraw
Joy1NotU:


	
	#;Bit order %---syxba--lrUDRLXXXXXXXXYYYYYYYY
	lis r6,0x0000
	ori r6,r6,0xFF00	#;0x0000FF00 - Left / Right

	and. r0,r3,r6		
	lis r6,0x0000
	ori r6,r6,0x4000	#;Test <0x40?
	cmpw r0,r6 
	bgt Joy2NotL
	cmpwi r13,0			#;At far left?
	beq Joy2NotL
	addi r13,r13,-2		#;Move Lrft
	li r15,1			#;Flag redraw
Joy2NotL:

	lis r6,0x0000
	ori r6,r6,0xC000	#;Test >0xC0?
	cmpw r0,r6 
	blt Joy2NotR
	cmpwi r13,640-96	#;At far right?
	beq Joy2NotR
	addi r13,r13,2		#;Move Right
	li r15,1			#;Flag redraw
Joy2NotR:
		
	lis r6,0x0000		#;0x000000FF - Up / Down
	ori r6,r6,0x00FF

	and. r0,r3,r6		#;Test =0?
	lis r6,0x0000
	ori r6,r6,0x0040	#;Test <0x40?
	cmpw r0,r6 
	bgt Joy2NotD		
	cmpwi r14,480-96	#;At bottom?
	beq Joy2NotD
	addi r14,r14,2		#;Move Down
	li r15,1			#;Flag redraw
Joy2NotD:

	lis r6,0x0000
	ori r6,r6,0x00C0	#;Test >0xC0?
	cmpw r0,r6 
	blt Joy2NotU
	cmpwi r14,0			#;At top?
	beq Joy2NotU
	addi r14,r14,-2		#;Move up
	li r15,1			#;Flag redraw
Joy2NotU:


	cmpwi r15,0				#;Check our draw flag
	beq InfLoop				#;No Moves? no? then loop

	bl RemoveSprites		#;Remove the sprite
	
	stw r11,U_PosX1(r10)	#;Save the update position
	stw r12,U_PosY1(r10)
	stw r13,U_PosX2(r10)
	stw r14,U_PosY2(r10)
	
	bl DrawSprites			#;Draw the new sprites

	lis r3,0x0001
	ori r3,r3,0x0000
DelayLoop:
	addi r3,r3,-1
	cmpwi r3,0
	bne DelayLoop			#;Crude delay
	
	b InfLoop
	
# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
DrawSprites:
	mflr r0 			#;R0=LR
	stwu r0,-4(SP)		#;Push LR onto SP/R1
		lis r10,UserRam@ha
		ori r10,r10,UserRam@l
			
		lwz r5,U_PosX2(r10)
		lwz r6,U_PosY2(r10)
		bl GetScreenPos
		
		lis r3,Bitmap2x@ha	 #;2x scale so we don't need to worry
		ori r3,r3,Bitmap2x@l #; about color issues
		
		li r5,48			#;width in pixels
		li r6,48			#;height in pairs of lines
		bl DrawBitmap2x
				
		lwz r5,U_PosX1(r10)
		lwz r6,U_PosY1(r10)
		bl GetScreenPos
		
		lis r3,Bitmap1x@ha
		ori r3,r3,Bitmap1x@l
		li r5,48/2			#;Width in 32 bit words (pairs of pixels)
		li r6,48
		bl DrawBitmap1x
	lwzu r0,0(sp)		#;POP LR
	addi sp,sp,4		#;POP
	mtlr r0				#;LR=R0	
	blr

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
GetScreenPos:		#;R5=X R6=Y... Result in R4
	lis r4,0xC050		 #;0xC0500000 - XFB address
	ori r4,r4,0x0000
	
	li r0,640*2			#;640 pixels per y-line,2 bytes per pixel
	mullw r6,r6,r0
	add r4,r4,r6
	
	li r0,2				#;2 bytes per X-Pixel
	mullw r5,r5,r0
	add r4,r4,r5
	blr 
		
# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
DrawBitmap2x:		
DrawBitmap2xY:
	mtspr ctr,r5		#;Width to -> CTR
	mr r8,r4		
DrawBitmap2xX:
	lwz r0,0(r3)		#;Get 2 pixels
	stw r0,0(r8)		#;Draw 2 pixels
	stw r0,1280(r8)		#;Duplicate one line down
	addi r8,r8,4
	addi r3,r3,4
	bdnz DrawBitmap2xX
	
	addi r4,r4,1280*2	#;Down two lines
	addi r6,r6,-1
	cmpwi r6,0
	bne DrawBitmap2xY
	blr
		
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

DrawBitmap1x:
DrawBitmap1xY:
	mtspr ctr,r5		#;Width to -> CTR
	mr r8,r4
DrawBitmap1xX:
	lwz r0,0(r3)		#;Get 2 pixels
	stw r0,0(r8)		#;Draw 2 pixels
	addi r8,r8,4
	addi r3,r3,4
	bdnz DrawBitmap1xX	
	
	addi r4,r4,1280		#;Down a line
	addi r6,r6,-1
	cmpwi r6,0
	bne DrawBitmap1xY
	blr
	
		
# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RemoveSprites:
	mflr r0 			#;R0=LR
	stwu r0,-4(SP)		#;Push LR onto SP/R1
		lis r10,UserRam@ha
		ori r10,r10,UserRam@l
		
		lwz r5,U_PosX1(r10)
		lwz r6,U_PosY1(r10)
		bl GetScreenPos
		
		lis r3,0x0080		#; YYBB - Black
		ori r3,r3,0x0080 	#; YYRR
		
		li r5,48/2			#;width in words (pairs of pixels)
		li r6,48			#;height in pairs of lines
		bl FillArea	
		
		lwz r5,U_PosX2(r10)
		lwz r6,U_PosY2(r10)
		bl GetScreenPos
		
		li r5,48			#;width in words (pairs of pixels)
		li r6,48*2			#;height in pairs of lines
		bl FillArea		
	lwzu r0,0(sp)		#;POP LR
	addi sp,sp,4		#;POP
	mtlr r0				#;LR=R0
	blr

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
FillArea:		#;R1=Fill 
FillAreaY:
	mtspr ctr,r5		#;CTR=Xpos
	mr r8,r4
FillAreaX:
	stw r3,0(r8)		#;Fill 2 bytes
	addi r8,r8,4
	bdnz FillAreaX	
	
	addi r4,r4,1280		#;Down a line
	addi r6,r6,-1
	cmpwi r6,0
	bne FillAreaY
	blr

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
CLS2:		
	lis r8,0xC050	#;0xC0500000 - XFB address (VRAM)

	lis r0,0x0002
	ori r0,r0,0x5800 #;0x25800=320*480 (We write 2 pixels each time)
	mtspr ctr,r0	#;Bytecount
CLS2b:
	stw r3,0(r8)	#;Fill 2 pixels
	addi r8,r8,4	#;Move Vram +4
	bdnz CLS2b		#;repeat
	blr	

#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

#;Joy init (doesn't actually seem to have any effect?)

#;0xCC006400 SIC0OUTBUF - SI Channel 0 Output Buffer (Joy-channel 1 Command) 
#;						  %--------CCCCCCCC0000000011111111	C=Command 0=Output0 1=Output1

#;0xCC006430 SIPOLL - SI Poll Register (Joy-channel Control (?) (Calibration gun ?))
#;						  %------XXXXXXXXXXYYYYYYYYEEEEVVVV	V=Vlbank copy E=Enable port Y=Ytimes X7 X lines 

#;0xCC006480 SI I/O buffer

#;0xCC006434 SICOMCSR - SI Communication Control Status Register (command)
#;						  %r?--?ccs-mmmmmmm-nnnnnnneb-----?


JoyInit:
	lis r8,0xCC00		#;0xCC006400	SI - Serial Interface
	ori r8,r8,0x6400
		
	lis r0,0x0040		#;0x00400300 - Command 
	ori r0,r0,0x0300
	stw r0,0(r8)		#;Cmd - 0xCC006400 SIC0OUTBUF - SI Channel 0
						#;				     Output Buffer
						
	lis r0,0x0000		#;0x000000F0 - 4 pads on
	ori r0,r0,0x00F0	#;enable the pads - 0xCC006430 SIPOLL
	stw r0,0x30(r8)		#;     				 SI Poll Register
	
	lis r0,0x0000
	ori r0,r0,0x0000
	stw r0,0x80(r8)		#;clear buffer - 0xCC006480 SI I/O buffer
	
WaitForSI:	
	lwz r0,0x34(r8)		#;0xCC006434 SICOMCSR - SI Communication
						#;     Control Status Register (command)
	lis r3,0x8000
	ori r3,r3,0x0000	#;wait for ready
	and. r0,r0,r3
	bne WaitForSI
	
	lwz r3,0x34(r8)		#;0xCC006434 SICOMCSR - SI Communication
						#;     Control Status Register (command)
	lis r0,0x8000
	ori r0,r0,0x0000	#;0x80000000 - Clear transfer
						#;             complete interrupt
	
	or r0,r3,r0
	stw r0,0x34(r8)		#;0xCC006434 SICOMCSR - SI Communication
						#;      Control Status Register (command)
	blr
	
# ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	

.data

.equ U_PosX1, 0			#; sprite 1 X,Y
.equ U_PosY1, 4

.equ U_PosX2, 8			#; sprite 2 X,Y
.equ U_PosY2, 12

UserRam:
PosX1: .long 0
PosY1: .long 0

PosX2: .long 100
PosY2: .long 100

Bitmap1x: 
	.incbin "/ResAll/RawSpriteGC_1x.RAW"
	
Bitmap2x: 
	.incbin "/ResAll/RawSpriteGC_2x.RAW"
	
	
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;			
.ifdef showtext
	.include "/SrcNGC/BasicFooter.asm"
.endif

	

	